#
# spec file for package gdb (Version 6.6)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

Name:           gdb
BuildRequires:  dejagnu gcc-c++ gcc-fortran gcc-java gcc-objc readline-devel
%ifarch %ix86 x86_64 ia64
BuildRequires:  libunwind-devel
%endif
URL:            http://www.gnu.org/software/gdb/
License:        GNU General Public License (GPL)
Group:          Development/Tools/Debuggers
Autoreqprov:    on
PreReq:         %{install_info_prereq}
Version:        6.6
Release:        13
Summary:        The GNU Debugger
Source:         gdb-%{version}.tar.bz2
Patch1:         gdb-misc.patch
Patch2:         warn.patch
Patch3:         readline-5.1-random.patch
Patch4:         readnever.patch
Patch5:         gstack.patch
Patch7:         ppc-dwarf2-cfi.patch
Patch8:         pie-relocate.diff
Patch9:         mst-solib-trampoline.diff
Patch10:        readline-callback.diff
Patch11:        loader_break.diff
Patch12:        ppc-long-double.diff
Patch13:        lr-frame-offset.diff
Patch15:        solib-extract-address.diff
Patch16:        pc-regnum.diff
Patch17:        show-endian.diff
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
You can use GDB to debug programs written in C, C++, Ada, and Modula-2.
GNU Fortran 77 support is also partially included.



Authors:
--------
    Doug Evans <dje@cygnus.com>
    Fred Fish <fnf@cygnus.com>
    Ian Lance Taylor <ian@cygnus.com>
    J.T. Conklin <jtc@cygnus.com>
    Jason Molenda <crash@cygnus.com>
    Jeffrey A. Law <law@cygnus.com>
    Jim Kingdon <kingdon@cygnus.com>
    Kung Hsu <kung@cygnus.com>
    Michael Meissner <meissner@cygnus.com>
    Per Bothner <bothner@cygnus.com>
    Peter Schauer <pes@regent.e-technik.tu-muenchen.de>
    Rob Savoye <rob@cygnus.com>
    Stan Shebs <shebs@cygnus.com>
    Steve Chamberlain <sac@cygnus.com>
    Stu Grossman <grossman@cygnus.com>

%prep
%setup -q
%patch1
%patch2
%patch3
%patch4
%patch5
%patch7
%patch8
%patch9
%patch10
cd gdb
%patch11
cd ..
%patch12
%patch13 -p1
%patch15
%patch16
%patch17 -p1

%build
CFLAGS="$RPM_OPT_FLAGS" \
./configure --prefix=%{_prefix} --libdir=%{_libdir} --infodir=%{_infodir} \
	    --mandir=%{_mandir} \
%ifarch ia64
	    --with-libunwind \
%else
	    --without-libunwind \
%endif
	    --with-separate-debug-dir=%{_prefix}/lib/debug \
	    --enable-64-bit-bfd --disable-werror \
	    --host=%{_target_cpu}-suse-linux
make %{?jobs:-j%jobs}
make info
make -k check || :

%install
make install-gdb install-info-gdb DESTDIR="$RPM_BUILD_ROOT"
echo '#!/bin/sh
exec gdb --tui "$@"' > $RPM_BUILD_ROOT%{_bindir}/gdbtui

%clean
rm -rf $RPM_BUILD_ROOT

%post
%install_info --info-dir=%{_infodir} %{_infodir}/annotate.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gdb.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gdbint.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/stabs.info.gz

%postun
%install_info_delete --info-dir=%{_infodir} %{_infodir}/annotate.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gdb.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gdbint.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/stabs.info.gz

%files
%defattr(-,root,root)
%doc COPYING COPYING.LIB gdb/README gdb/NEWS
%{_bindir}/gdb
%{_bindir}/gdbtui
%{_bindir}/gstack
%{_mandir}/man1/gdb.1.gz
%{_mandir}/man1/gdbtui.1.gz
%{_infodir}/annotate.info*.gz
%{_infodir}/gdb.info*.gz
%{_infodir}/gdbint.info*.gz
%{_infodir}/stabs.info*.gz
%ifnarch alpha sparc sparc64
%{_bindir}/gdbserver
%{_mandir}/man1/gdbserver.1.gz
%endif

%changelog
* Mon Mar 05 2007 - schwab@suse.de
- Remove obsolete patch.
- Fix show endian.
* Thu Jan 11 2007 - schwab@suse.de
- Fix unchecked use of PC_REGNUM.
* Wed Dec 20 2006 - schwab@suse.de
- Update to gdb 6.6.
  * New targets
  Xtensa				xtensa-elf
  Cell Broadband Engine SPU	spu-elf
  * GDB can now be configured as a cross-debugger targeting native Windows
  (mingw32) or Cygwin.  It can communicate with a remote debugging stub
  running on a Windows system over TCP/IP to debug Windows programs.
  * The GDB remote stub, gdbserver, has been updated to support Windows and
  Cygwin debugging.  Both single-threaded and multi-threaded programs are
  supported.
  * The "set trust-readonly-sections" command works again.  This command was
  broken in GDB 6.3, 6.4, and 6.5.
  * Support for GNU/Linux Thread Local Storage (TLS, per-thread variables) no
  longer requires symbolic debug information (e.g. DWARF-2).
  * New commands
  set substitute-path
  unset substitute-path
  show substitute-path
  Manage a list of substitution rules that GDB uses to rewrite the name
  of the directories where the sources are located. This can be useful
  for instance when the sources were moved to a different location
  between compilation and debugging.
  set trace-commands
  show trace-commands
  Print each CLI command as it is executed.  Each command is prefixed with
  a number of `+' symbols representing the nesting depth.
  The source command now has a `-v' option to enable the same feature.
  * REMOVED features
  The ARM Demon monitor support (RDP protocol, "target rdp").
  Kernel Object Display, an embedded debugging feature which only worked with
  an obsolete version of Cisco IOS.
  The 'set download-write-size' and 'show download-write-size' commands.
  * New remote packets
  qSupported:
  Tell a stub about GDB client features, and request remote target features.
  The first feature implemented is PacketSize, which allows the target to
  specify the size of packets it can handle - to minimize the number of
  packets required and improve performance when connected to a remote
  target.
  qXfer:auxv:read:
  Fetch an OS auxilliary vector from the remote stub.  This packet is a
  more efficient replacement for qPart:auxv:read.
  * Removed remote packets
  qPart:auxv:read:
  This packet has been replaced by qXfer:auxv:read.  Only GDB 6.4 and 6.5
  used it, and only gdbserver implemented it.
* Sat Dec 02 2006 - schwab@suse.de
- Update to gdb 6.5.90.
* Sat Oct 28 2006 - schwab@suse.de
- Rename detach-fork to detach fork.
* Tue Oct 24 2006 - schwab@suse.de
- Better fix for function descriptor handling on ppc64.
* Fri Aug 25 2006 - schwab@suse.de
- Minimal support for .gnu.hash.
* Thu Aug 24 2006 - schwab@suse.de
- Fix off-by-one in add_symbol_file_command [#200831].
* Fri Aug 11 2006 - schwab@suse.de
- Correctly extend addresses read from link map.
* Sun Jul 16 2006 - schwab@suse.de
- Fix function decriptor handing on ppc64.
* Wed Jun 21 2006 - schwab@suse.de
- Update to final gdb 6.5.
* Sat Jun 03 2006 - schwab@suse.de
- Update to gdb 6.5 RC 1.
* Wed May 31 2006 - schwab@suse.de
- Set long double size to 16 [#180103].
* Mon May 22 2006 - schwab@suse.de
- Update to gdb 6.4.90 snapshot 20060522.
* Sun Apr 23 2006 - schwab@suse.de
- Add patch to avoid losing compilation directory.
- Fix a parallel build problem.
* Tue Apr 04 2006 - schwab@suse.de
- Relocate PIEs.
* Mon Mar 27 2006 - schwab@suse.de
- Handle .eh_frame register encoding that is different from .dwarf_frame.
- Remove obsolete patch.
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 23 2006 - schwab@suse.de
- Add fix for PIC prologue analyzer on powerpc.
* Wed Dec 14 2005 - schwab@suse.de
- Add fix for observer notify queue after attach.
* Fri Dec 02 2005 - schwab@suse.de
- Update to gdb 6.4.
* Tue Nov 22 2005 - schwab@suse.de
- Update to gdb 6.3.90.
* Fri Nov 04 2005 - schwab@suse.de
- Update to gdb-6.3.50 snapshot 20051103.
* Mon Oct 03 2005 - schwab@suse.de
- Update to gdb 6.3.50 snapshot 20051003.
* Mon Sep 19 2005 - schwab@suse.de
- Fix warnings.
* Sun Aug 21 2005 - schwab@suse.de
- Add DWARF CFI unwinder on ppc.
* Mon Jun 20 2005 - schwab@suse.de
- Require libunwind-devel on ia64.
* Thu Jun 09 2005 - schwab@suse.de
- Add patch for ia64 vDSO support and unwinding through signals and
  syscalls [#60766].
* Mon Apr 11 2005 - schwab@suse.de
- Fix backtrace through vsyscall [#63483].
* Mon Apr 11 2005 - schwab@suse.de
- Add patch to fix bugs in rs6000/powerpc register set functions.
- Fix a testsuite bug.
* Sun Mar 06 2005 - schwab@suse.de
- Add patch to suppress fork attach/detach messages.
* Wed Mar 02 2005 - schwab@suse.de
- Add patch to fix following vfork from a secondary thread.
* Mon Feb 28 2005 - schwab@suse.de
- Don't ignore DW_TAG_member [#66406].
* Tue Feb 01 2005 - schwab@suse.de
- Find separate debug symbol files in /usr/lib/debug by default.
* Thu Jan 27 2005 - schwab@suse.de
- Add patch to handle back-to-back and nested signals.
* Thu Jan 27 2005 - schwab@suse.de
- Add patch to implement reggroups for ppc.
* Wed Jan 26 2005 - schwab@suse.de
- Add patch to implement PPC GNU/Linux sigtramp frame code.
* Wed Jan 12 2005 - schwab@suse.de
- Don't error out when encountering an unavailable value.
* Fri Dec 03 2004 - schwab@suse.de
- Downgrade errors to warnings during backtrace [#48484].
- Undocument --readnever since it may not be supported by future releases.
- Fix patches from last change.
* Fri Dec 03 2004 - kukuk@suse.de
- Add --readnever option as workaround for [#48485]
* Sun Nov 14 2004 - schwab@suse.de
- Add libunwind-devel to neededforbuild.
* Sat Nov 13 2004 - schwab@suse.de
- Fix missing dependencies.
* Wed Nov 10 2004 - schwab@suse.de
- Version 6.2.91 renamed to 6.3.
* Tue Nov 09 2004 - schwab@suse.de
- Update to gdb 6.2.91 (6.3 release candidate).
* Mon Nov 08 2004 - schwab@suse.de
- Revert last change.
- Fix typo.
* Mon Nov 08 2004 - uli@suse.de
- fixed to build on s390*
* Mon Oct 25 2004 - schwab@suse.de
- Fix building gdbserver on x86-64.
* Mon Oct 25 2004 - schwab@suse.de
- Update to gdb 6.2.90.
- Use libunwind on ia64.
* Thu Sep 09 2004 - schwab@suse.de
- Update to gdb 6.2.1.
* Wed Aug 25 2004 - schwab@suse.de
- Fix deadlock in child_wait [#42796].
* Tue Aug 24 2004 - schwab@suse.de
- Import latest changes from 6.2 branch.
* Fri Jul 30 2004 - schwab@suse.de
- Update to gdb 6.2.
* Thu Jul 29 2004 - schwab@suse.de
- Update to gdb 6.1.92.
* Mon Jul 26 2004 - schwab@suse.de
- Fix handling of relative filenames in DWARF2 .debug_line.
* Mon Jul 19 2004 - schwab@suse.de
- Update to gdb 6.1.91.
* Thu Jun 24 2004 - schwab@suse.de
- Better handling of dying threads.
* Fri Jun 18 2004 - schwab@suse.de
- Update to gdb 6.1.1.
* Tue May 25 2004 - schwab@suse.de
- Fix handling of short lived threads [#40841].
* Sat May 01 2004 - schwab@suse.de
- Restore removed hunk.
* Fri Apr 30 2004 - meissner@suse.de
- applied 3 patches to fix problems on ppc64. #39394
* Sat Apr 17 2004 - schwab@suse.de
- Pacify autobuild.
* Mon Apr 05 2004 - schwab@suse.de
- Version 6.0.92 has been renamed to 6.1.
* Sat Apr 03 2004 - schwab@suse.de
- Update to gdb 6.0.92 (6.1 release candidate).
* Tue Mar 30 2004 - schwab@suse.de
- Fix invalid use of va_list.
* Mon Mar 29 2004 - schwab@suse.de
- Update to gdb 6.0.91.
* Mon Mar 29 2004 - schwab@suse.de
- Update to current CVS.
* Fri Mar 19 2004 - schwab@suse.de
- Fix last change: don't disable testsuite.
* Wed Mar 17 2004 - mludvig@suse.cz
- Added opcodes for VIA PadLock instructions.
* Tue Mar 02 2004 - schwab@suse.de
- Update to gdb 6.0.90.
- Run testsuite.
* Thu Jan 08 2004 - schwab@suse.de
- Fix gate area range.
* Wed Dec 10 2003 - schwab@suse.de
- Support DW_TAG_subrange_type.
- Backport recent ia64 improvements from mainline.
* Tue Oct 21 2003 - mludvig@
- Add support for debugging both i386 and amd64 apps by a single
  amd64 GDB binary.
* Mon Oct 20 2003 - mludvig@suse.cz
- Correctly interpret symbol tables for debugging kernel modules
  (gdb6-symtab-minimal.diff)
- Fixed support for GCC variable tracking (gdb6-vartrack.diff)
- Fixed support for Fortran arrays (gdb6-fortranarray.diff)
* Tue Oct 07 2003 - schwab@suse.de
- Hack to build on sparc.
* Mon Oct 06 2003 - schwab@suse.de
- Update to gdb 6.0.
* Fri Oct 03 2003 - kukuk@suse.de
- Remove unused tetex from neededforbuild
* Mon Sep 29 2003 - schwab@suse.de
- Update to gdb 5.3.93 pre-release.
* Wed Sep 17 2003 - schwab@suse.de
- Remove debugging hooks.
* Wed Sep 17 2003 - schwab@suse.de
- Ignore more insns during i386 prologue decoding [#30288].
- Fix hash table mixup in bfd_simple interface.
* Tue Sep 16 2003 - schwab@suse.de
- Update to gdb 5.3.92 pre-release.
  * Fixes bug 31033.
* Wed Sep 03 2003 - schwab@suse.de
- Update to gdb 5.3.91 pre-release.
* Tue Aug 19 2003 - schwab@suse.de
- Update to gdb 5.3.90 2003-08-19 cvs snapshot.
* Mon Jun 23 2003 - kukuk@suse.de
- Fix compiling on SPARC
* Tue Jun 10 2003 - schwab@suse.de
- Don't package mmalloc.info, since libmmalloc isn't included either.
* Thu May 15 2003 - schwab@suse.de
- Remove unwanted files.
* Thu Apr 24 2003 - ro@suse.de
- fix install_info --delete call and move from preun to postun
* Fri Apr 11 2003 - mludvig@suse.cz
- Fix read_2u() function in dwarf2cfi.c
* Thu Apr 10 2003 - mludvig@suse.cz
- Add 'info cfi <address>' command.
- Fix off-by-4 bug in the CFI parser.
* Mon Apr 07 2003 - schwab@suse.de
- Only delete info entries when removing last version.
* Thu Mar 27 2003 - schwab@suse.de
- Fix specfile.
* Thu Mar 06 2003 - aj@suse.de
- Fix neededforbuild.
* Wed Feb 26 2003 - mludvig@suse.cz
- Added loclist support
- Fixed eh_frame parsing problems
- Updated for proposed x86-64 ABI change
* Thu Feb 06 2003 - schwab@suse.de
- Use %%install_info.
* Tue Feb 04 2003 - schwab@suse.de
- Enable TUI.
* Sun Jan 26 2003 - olh@suse.de
- add inital native ppc64 support
* Thu Jan 09 2003 - mludvig@suse.cz
- Fixed compilation problem with last gdb-asmbtrace.diff.
  No new feature.
* Tue Jan 07 2003 - mludvig@suse.cz
- Several Dwarf2 and x86-64 specific changes
  * Added ability to do backtrace from some functions
  without debug info (patch gdb-asmbtrace.diff)
  * Fixed crash on re-run of a debugged program.
  * Added some more verbosity to dwarf2cfi engine.
* Thu Dec 12 2002 - schwab@suse.de
- Update to gdb 5.3.
  * GNU/Linux shared library multi-threaded performance improved.
  * ``gdbserver'' now supports multi-threaded applications on some targets
  * GDB now supports C/C++ preprocessor macros.
* Fri Oct 11 2002 - aj@suse.de
- Handle gcc code generated by gcc -f-elimante-dwarf2-dups -g.
* Thu Sep 26 2002 - schwab@suse.de
- Avoid installing libbfd, libopcodes, libiberty and libmmalloc [#20199].
* Wed Sep 18 2002 - sf@suse.de
- added patch from mludvig to remove framepointer on x86_64
* Wed Sep 04 2002 - kukuk@suse.de
- Add Patch for reading SPARC core files
* Tue Sep 03 2002 - schwab@suse.de
- Remove tetex from neededforbuild.
* Wed Jul 24 2002 - schwab@suse.de
- Update to gdb 5.2.1.
* Thu Jul 18 2002 - mludvig@suse.de
- Fix PLT recognisation.
* Mon Jul 08 2002 - schwab@suse.de
- Add fix for memory leak.
* Tue Jul 02 2002 - mludvig@suse.cz
- removed my previous patches
- added a huge one suse-521-x8664.diff
* Thu Jun 06 2002 - sf@suse.de
- added fpregset.diff (from mludvig@suse.de)
- added dwarf2cfi.diff (from mludvig@suse.de)
* Wed May 15 2002 - sf@suse.de
- added some dwarf2-patches for x86_64
  (from mludvig@suse.de)
* Thu May 09 2002 - schwab@suse.de
- Fix breakpoints on MLX bundle.
* Mon May 06 2002 - schwab@suse.de
- Sparc doesn't have gdbserver either.
* Sun May 05 2002 - schwab@suse.de
- Update to gdb 5.2.
- Gdbserver now available for all but alpha.
* Fri Jan 25 2002 - schwab@suse.de
- Update to gdb 5.1.1.
* Thu Nov 22 2001 - schwab@suse.de
- Update to gdb 5.1.
- Build and install gdbserver on i386 and ia64.
* Sat Aug 18 2001 - schwab@suse.de
- Update to gdb snapthot 20010316.
* Fri May 18 2001 - schwab@suse.de
- Include ia64 warning patches (from nadvornik@suse.cz).
* Thu Apr 12 2001 - schwab@suse.de
- Remove declaration of tilde_expand, now in readline header.
* Sun Apr 01 2001 - schwab@suse.de
- Fix hardware watchpoints on ia64.
* Fri Mar 30 2001 - schwab@suse.de
- Fix crash on info architecture (#6865).
* Wed Mar 28 2001 - schwab@suse.de
- Use installed readline library.
* Tue Mar 06 2001 - schwab@suse.de
- Remove some ia64 hacks.
* Tue Dec 12 2000 - schwab@suse.de
- Improve handling of breakpoints in shared libraries.
* Fri Nov 17 2000 - kukuk@suse.de
- Update to working gdb snapshot
* Wed Sep 27 2000 - fober@suse.de
- s390: added s390-sigregs-SuSE.patch
* Thu Sep 14 2000 - fober@suse.de
- s390: incorporate new ibm patches for gdb 5.0
* Wed Sep 06 2000 - fober@suse.de
- s390: incorporate ibm patches for gdb 5.0
* Fri Jun 30 2000 - kukuk@suse.de
- Add gdb-5.0
* Tue Apr 04 2000 - bk@suse.de
- s390 team added s390 support
* Tue Mar 21 2000 - schwab@suse.de
- Fix core dump reading (#2586).
* Fri Feb 04 2000 - kukuk@suse.de
- Add patches for PPC
- Move /usr/info -> /usr/share/info
* Mon Dec 06 1999 - kukuk@suse.de
- Remove gdb 4.17
- Add gdb 4.18 fixes for SPARC
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Fri Sep 03 1999 - kukuk@suse.de
- Use RPM values for CFLAGS and configure
* Tue Aug 24 1999 - uli@suse.de
- added -fsigned-char to CFLAGS (PPC)
* Mon Aug 23 1999 - kukuk@suse.de
- Add gdb 4.18 thread patch from RH
* Mon Jul 19 1999 - florian@suse.de
- add gdb-4.17.0.12 as /usr/bin/gdb-4.17
* Wed Jul 07 1999 - kukuk@suse.de
- update to 4.18 using diff from jurix
* Mon Feb 22 1999 - ro@suse.de
- update to 4.17.0.11 using diff from jurix
* Thu Jan 21 1999 - ro@suse.de
- update to 4.17.0.8
* Thu Oct 01 1998 - ro@suse.de
- update to 4.17.0.4 using jurix-diff
* Tue Sep 15 1998 - ro@suse.de
- hacked for GLIBC: include sys/ucontext and sys/ptrace where needed
- catch strup redeclarations
- cleaned up patch-sequence
* Wed Oct 29 1997 - florian@suse.de
- fix <sys/procfs.h> in libc to correctly support core-files
- add bug-fix to read symbols from dynamic symbol tables
- apply all patches from debian gdb-4.16-11
* Thu Jan 02 1997 - florian@suse.de
  Neue Version 4.16.
  gdb kompiliert nur mit libc 5.4.7 richtig. Mit 5.2.18 kann gdb
  keine core-files lesen.
  Ich waere dafuer, einfach das Binary von libc 5.4.7 zu benutzen.
  Wird schon funktionieren...
